<html>
<head>
<title>OgreGLFrameBufferObject.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLFrameBufferObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLFrameBufferObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreGLFBO_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreGLFBO_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLRenderTexture_8h.html">OgreGLRenderTexture.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLContext_8h.html">OgreGLContext.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035     
<a name="l00038"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html">00038</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLFrameBufferObject.html" title="Frame Buffer Object abstraction.">GLFrameBufferObject</a>
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keyword">public</span>:
<a name="l00041"></a>00041         <a class="code" href="classOgre_1_1GLFrameBufferObject.html" title="Frame Buffer Object abstraction.">GLFrameBufferObject</a>(<a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a> *manager, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00042"></a>00042         ~<a class="code" href="classOgre_1_1GLFrameBufferObject.html" title="Frame Buffer Object abstraction.">GLFrameBufferObject</a>();
<a name="l00043"></a>00043 
<a name="l00047"></a>00047         <span class="keywordtype">void</span> bindSurface(<span class="keywordtype">size_t</span> attachment, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;target);
<a name="l00050"></a>00050         <span class="keywordtype">void</span> unbindSurface(<span class="keywordtype">size_t</span> attachment);
<a name="l00051"></a>00051         
<a name="l00054"></a>00054         <span class="keywordtype">void</span> bind();
<a name="l00055"></a>00055 
<a name="l00058"></a>00058         <span class="keywordtype">void</span> swapBuffers();
<a name="l00059"></a>00059 
<a name="l00065"></a>00065         <span class="keywordtype">void</span> attachDepthBuffer( <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> *depthBuffer );
<a name="l00066"></a>00066         <span class="keywordtype">void</span> detachDepthBuffer();
<a name="l00067"></a>00067         
<a name="l00069"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a16709c5ce9ec817f88f24bda6696191b">00069</a>         GLuint <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a16709c5ce9ec817f88f24bda6696191b" title="Get the GL id for the FBO.">getGLFBOID</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFB; }
<a name="l00071"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a5379d2d582c3055f5232d2219b921111">00071</a>         GLuint <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a5379d2d582c3055f5232d2219b921111" title="Get the GL id for the multisample FBO.">getGLMultisampleFBOID</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMultisampleFB; }
<a name="l00072"></a>00072         
<a name="l00074"></a>00074         <span class="keywordtype">size_t</span> getWidth();
<a name="l00075"></a>00075         <span class="keywordtype">size_t</span> getHeight();
<a name="l00076"></a>00076         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getFormat();
<a name="l00077"></a>00077         GLsizei getFSAA();
<a name="l00078"></a>00078         
<a name="l00079"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a937228d22ea15178d39887da988365c3">00079</a>         <a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a> *<a class="code" href="classOgre_1_1GLFrameBufferObject.html#a937228d22ea15178d39887da988365c3">getManager</a>() { <span class="keywordflow">return</span> mManager; }
<a name="l00080"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a7a241ec56436d27faa640e1631443b21">00080</a>         <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> &amp;<a class="code" href="classOgre_1_1GLFrameBufferObject.html#a7a241ec56436d27faa640e1631443b21">getSurface</a>(<span class="keywordtype">size_t</span> attachment) { <span class="keywordflow">return</span> mColour[attachment]; }
<a name="l00081"></a>00081     <span class="keyword">private</span>:
<a name="l00082"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a72f41ff431192df59ee00d6b53c7221b">00082</a>         <a class="code" href="classOgre_1_1GLFBOManager.html" title="Factory for GL Frame Buffer Objects, and related things.">GLFBOManager</a> *<a class="code" href="classOgre_1_1GLFrameBufferObject.html#a72f41ff431192df59ee00d6b53c7221b">mManager</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a2e2945449d763b22d6b5c4957104ceb5">00083</a>         GLsizei <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a2e2945449d763b22d6b5c4957104ceb5">mNumSamples</a>;
<a name="l00084"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#ae3bef8435636336be593676d53e5fdb9">00084</a>         GLuint <a class="code" href="classOgre_1_1GLFrameBufferObject.html#ae3bef8435636336be593676d53e5fdb9">mFB</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a2c16c481cd35b1aede28fdc107351205">00085</a>         GLuint <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a2c16c481cd35b1aede28fdc107351205">mMultisampleFB</a>;
<a name="l00086"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a56fa38c3d712915bb4f9caed7244bc00">00086</a>         <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a56fa38c3d712915bb4f9caed7244bc00">mMultisampleColourBuffer</a>;
<a name="l00087"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#ae47df9aefb647389e52270c84ad92601">00087</a>         <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> <a class="code" href="classOgre_1_1GLFrameBufferObject.html#ae47df9aefb647389e52270c84ad92601">mDepth</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a24f661a94d4596ff341783002c7374db">00088</a>         <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> <a class="code" href="classOgre_1_1GLFrameBufferObject.html#a24f661a94d4596ff341783002c7374db">mStencil</a>;
<a name="l00089"></a>00089         <span class="comment">// Arbitrary number of texture surfaces</span>
<a name="l00090"></a><a class="code" href="classOgre_1_1GLFrameBufferObject.html#a01912f83bbfdcdfd7a595fca804228e4">00090</a>         <a class="code" href="structOgre_1_1GLSurfaceDesc.html" title="GL surface descriptor.">GLSurfaceDesc</a> mColour[<a class="code" href="OgreConfig_8h.html#a1555343fe7aade0966aa442f2e0c16f5" title="Define max number of multiple render targets (MRTs) to render to at once.">OGRE_MAX_MULTIPLE_RENDER_TARGETS</a>];
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00100"></a>00100         <span class="keywordtype">void</span> initialise();
<a name="l00101"></a>00101     };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
